/*
 * QuickThreads -- Threads-building toolkit.
 * Copyright (c) 1993 by David Keppel
 * Copyright (c) 2003 by Personal Media Corporation
 *
 * Permission to use, copy, modify and distribute this software and
 * its documentation for any purpose and without fee is hereby
 * granted, provided that the above copyright notice and this notice
 * appear in all copies.  This software is provided as a
 * proof-of-concept and for demonstration purposes; there is no
 * representation about the suitability of this software for any
 * purpose.
 */

	.globl b_call_reg
	.globl b_call_imm
	.globl b_add
	.globl b_load

	.ent b_null
b_null:
	j	$31
	.end b_null

	.ent b_call_reg
b_call_reg:
	la	$5, b_null
	move	$6, $31
$L0:
	jal	$5
	jal	$5
	jal	$5
	jal	$5
	jal	$5

	subu	$4, $4, 5
	bgtz	$4, $L0
	j	$6
	.end b_call_reg


	.ent b_call_imm
b_call_imm:
	move	$6, $31
$L1:
	jal	b_null
	jal	b_null
	jal	b_null
	jal	b_null
	jal	b_null

	subu	$4, $4, 5
	bgtz	$4, $L1
	j	$6
	.end b_call_imm


	.ent b_add
b_add:
	move	$5, $4
	move	$6, $4
	move	$7, $4
	move	$8, $4
$L2:
	subu	$4, $4, 5
	subu	$5, $5, 5
	subu	$6, $6, 5
	subu	$7, $7, 5
	subu	$8, $8, 5

	subu	$4, $4, 5
	subu	$5, $5, 5
	subu	$6, $6, 5
	subu	$7, $7, 5
	subu	$8, $8, 5

	bgtz	$4, $L2
	j	$31
	.end b_add


	.ent b_load
b_load:
$L3:
	lw	$0, 0($sp)
	lw	$0, 4($sp)
	lw	$0, 8($sp)
	lw	$0, 12($sp)
	lw	$0, 16($sp)

	lw	$0, 20($sp)
	lw	$0, 24($sp)
	lw	$0, 28($sp)
	lw	$0, 32($sp)
	lw	$0, 36($sp)

	sub	$4, $4, 10
	bgtz	$4, $L3
	j	$31
	.end b_load
